<ng-template #extend>
  <div class="error">
    <em nz-icon nzType="close-circle" nzTheme="outline"></em>
    <span>{{ 'modelOrganization.correctionOrganization.error.extend' | translate }}</span>
  </div>
</ng-template>

<ng-template #size>
  <div class="error">
    <em nz-icon nzType="close-circle" nzTheme="outline"></em>
    <span>{{ 'modelOrganization.correctionOrganization.error.size' | translate }}</span>
  </div>
</ng-template>

<ng-template #file>
  <div class="error">
    <em nz-icon nzType="close-circle" nzTheme="outline"></em>
    <span>{{ 'modelOrganization.correctionOrganization.error.file' | translate }}</span>
  </div>
</ng-template>

<div class="container-fluid">
  <form [formGroup]="createOrganization" nz-form>
    <div class="form">
      <div nz-row class="form-row">
        <div nz-col nzSpan="5" class="form-row__left">
          <mb-input-text
            formControlName="description"
            [isFocus]='true'
            [mbType]="isSubmit && createOrganization.controls['description'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmit && createOrganization.controls['description'].errors !== null"
            [mbErrors]="createOrganization.controls['description'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'required',
                errorDescription: 'modelOrganization.correctionOrganization.error.des' | translate
              }
            ]"
            mbPlaceholderText="{{ 'modelOrganization.correctionOrganization.placeHoder.type' | translate }}"
            mbLabelText="{{
              shareData.type
                ? ('modelOrganization.correctionOrganization.label.reasonCorrection' | translate)
                : ('modelOrganization.correctionOrganization.label.reasonAdjust' | translate)
            }} <span class='label__required'>*</span>"
          ></mb-input-text>
        </div>
        <div nz-col nzSpan="5" class="form-row__left">
          <mb-date-picker
            mbMode="time"
            mbFormat="dd/MM/yyyy"
            [mbType]="isSubmit && createOrganization.controls['dateVisible'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmit && createOrganization.controls['dateVisible'].errors !== null"
            [mbErrors]="createOrganization.controls['dateVisible'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'required',
                errorDescription: 'modelOrganization.correctionOrganization.error.date' | translate
              }
            ]"
            mbLabelText="Ngày hiệu lực <span class='label__required'>*</span>"
            formControlName="dateVisible"
          >
          </mb-date-picker>
        </div>
        <div nz-col nzSpan="5" class="form-row__center">
          <mb-input-text
            formControlName="sapNo"
            [mbType]="isSubmit && createOrganization.controls['sapNo'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmit && createOrganization.controls['sapNo'].errors !== null"
            [mbErrors]="createOrganization.controls['sapNo'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'required',
                errorDescription: 'modelOrganization.correctionOrganization.error.sapNo' | translate
              }
            ]"
            mbPlaceholderText="{{ 'modelOrganization.correctionOrganization.placeHoder.type' | translate }}"
            mbLabelText="{{
              'modelOrganization.correctionOrganization.label.numOfReport' | translate
            }} <span class='label__required'>*</span>"
          ></mb-input-text>
        </div>
        <div nz-col nzSpan="5" class="form-row__right">
          <div class="title-input">
            <span nz-typography class="form-row__label">{{
              'modelOrganization.correctionOrganization.label.attachment' | translate
            }}</span>
            <p class="required">*</p>
          </div>

          <nz-form-item>
            <nz-form-control
              nzValidateStatus=""
              [nzErrorTip]="
                createOrganization.controls.attach.errors?.extend
                  ? extend
                  : createOrganization.controls.attach.errors?.size
                  ? size
                  : file
              "
            >
              <div style="display: flex; margin-top: 0.4rem">
                <img alt="" (click)="fileInput.click()" src="assets/images/icon/Group 14048.svg" />
                <input
                  id="file"
                  accept=".pdf"
                  hidden
                  formControlName="attach"
                  type="file"
                  #fileInput
                  (change)="handleFileInput($event)"
                />
                <mat-chip (removed)="removeChip()" *ngIf="fileData.fileName" class="form-row__right--mat-chip-file">
                  <span nz-tooltip [nzTooltipTitle]="fileData.fileName" class="form-row__right--fileName">
                    {{ fileData.fileName }}
                  </span>

                  <button matChipRemove class="form-row__right--button">
                    <em nz-icon nzType="close-circle" nzTheme="outline"></em>
                  </button>
                </mat-chip>
              </div>
            </nz-form-control>
          </nz-form-item>
        </div>
      </div>

      <div nz-row class="form-row">
        <div nz-col nzSpan="5" class="form-row__left">
          <div>
            <span nz-typography class="form-row__label">{{
              'modelOrganization.correctionOrganization.label.superiorUnit' | translate
            }}</span>
          </div>
          <label class="form-row__text-view"> {{ createOrganization.value.parent }}</label>
        </div>
        <div nz-col nzSpan="5" class="form-row__left">
          <mb-select
            [mbDataSelects]="areas"
            *ngIf="!shareData.disable"
            mbKeyLabel="lvaMean"
            mbKeyValue="lvaValue"
            mbLabelText="{{ 'modelOrganization.correctionOrganization.label.area' | translate }}"
            mbPlaceholder="{{ 'modelOrganization.correctionOrganization.placeHoder.chooseOrType' | translate }}"
            [mbOptionHeightPx]="58"
            formControlName="area"
          ></mb-select>
          <div *ngIf="shareData.disable">
            <span nz-typography class="form-row__label">{{
              'modelOrganization.correctionOrganization.label.area' | translate
            }}</span>
          </div>
          <div *ngIf="shareData.disable">
            <span>{{ createOrganization.value.regionView }}</span>
          </div>
        </div>
        <div nz-col nzSpan="5" class="form-row__center">
          <mb-select
            [mbDataSelects]="types"
            *ngIf="!shareData.disable"
            mbKeyLabel="lvaMean"
            mbKeyValue="lvaValue"
            mbLabelText="{{ 'modelOrganization.correctionOrganization.label.typeBranch' | translate }}"
            mbPlaceholder="{{ 'modelOrganization.correctionOrganization.placeHoder.chooseOrType' | translate }}"
            (mbSelect)="selectBranch($event)"
            [mbOptionHeightPx]="58"
            formControlName="type"
          ></mb-select>
          <div *ngIf="shareData.disable">
            <span nz-typography class="form-row__label">{{
              'modelOrganization.correctionOrganization.label.typeBranch' | translate
            }}</span>
          </div>
          <div *ngIf="shareData.disable">
            <span>{{ createOrganization.value.branchView }}</span>
          </div>
        </div>
        <div nz-col nzSpan="5" class="form-row__center" *ngIf="createOrganization.value.type === legalBranch">
          <div *ngIf="!shareData.disable">
            <mb-select
              [mbDataSelects]="legalBranchs"
              *ngIf="!shareData.disable"
              mbKeyLabel="orgName"
              mbKeyValue="orgId"
              mbLabelText="{{
                'modelOrganization.correctionOrganization.label.legalBranch' | translate
              }} <span class='label__required'>*</span>"
              mbPlaceholder="{{ 'modelOrganization.correctionOrganization.placeHoder.chooseOrType' | translate }}"
              [mbType]="isSubmit && createOrganization.controls['legalBranch'].errors ? 'error' : 'default'"
              [mbShowError]="isSubmit && createOrganization.controls['legalBranch'].errors !== null"
              [mbErrors]="createOrganization.controls['legalBranch'].errors"
              [mbErrorDefs]="[
                {
                  errorName: 'required',
                  errorDescription: 'modelOrganization.correctionOrganization.error.legalBranch' | translate
                }
              ]"
              [mbOptionHeightPx]="58"
              formControlName="legalBranch"
            ></mb-select>
          </div>
          <div class="title-input" *ngIf="shareData.disable">
            <span nz-typography class="form-row__label">{{
              'modelOrganization.correctionOrganization.label.legalBranch' | translate
            }}</span>
            <p class="required">*</p>
          </div>
          <div *ngIf="shareData.disable">
            <span>{{ createOrganization.value.legalBranchName }}</span>
          </div>
        </div>
      </div>
    </div>

    <div nz-row class="template">
      <div class="jd-table">
        <nz-table
          #basicTable
          nzTableLayout="fixed"
          [nzData]="shareData.data ? [''] : []"
          [nzFrontPagination]="false"
          [nzShowPagination]="false"
          [nzLoading]="shareData.loading"
          nzSize="small"
          nzBordered
        >
          <thead>
            <tr>
              <th scope="col" class="jd-table__label" nzWidth="35%">
                {{ 'modelOrganization.correctionOrganization.label.infoUnit' | translate }}
              </th>
              <th scope="col" class="jd-table__label" widthDerective [widthCell]="shareData.width">
                {{ 'modelOrganization.correctionOrganization.label.feature' | translate }}
              </th>
              <th scope="col" class="jd-table__label" widthDerective [widthCell]="shareData.width">
                {{ 'modelOrganization.correctionOrganization.label.job' | translate }}
              </th>
              <th scope="col" class="jd-table__label" widthDerective [widthCell]="'15%'" *ngIf="shareData.type">
                {{ 'modelOrganization.correctionOrganization.label.invalidDate' | translate }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td>
                <div class="fun-row">
                  <div class="fun-row__form">
                    <div
                      *ngIf="
                        (isSubmit && createOrganization.controls['orgName'].errors) ||
                        createOrganization.controls['orgName'].errors?.pattern
                      "
                      style="height: 1.4rem"
                    ></div>
                    <mb-input-text
                      formControlName="orgName"
                      [defaultInput]="true"
                      [mbType]="
                        (isSubmit && createOrganization.controls['orgName'].errors) ||
                        createOrganization.controls['orgName'].errors?.pattern
                          ? 'error'
                          : 'default'
                      "
                      [mbShowError]="
                        (isSubmit && createOrganization.controls['orgName'].errors !== null) ||
                        createOrganization.controls['orgName'].errors?.patters !== null
                      "
                      [mbErrors]="createOrganization.controls['orgName'].errors"
                      [mbErrorDefs]="[
                        {
                          errorName: 'required',
                          errorDescription: 'modelOrganization.correctionOrganization.error.dup' | translate
                        },
                        {
                          errorName: 'pattern',
                          errorDescription: 'modelOrganization.correctionOrganization.error.specialSymbol' | translate
                        }
                      ]"
                      mbPlaceholderText="{{ 'modelOrganization.correctionOrganization.placeHoder.type' | translate }}"
                      [mbShowFlexEnd]="false"
                    ></mb-input-text>
                  </div>
                </div>
              </td>

              <td>
                <div *ngFor="let fun of shareData.data.orgAttributes; let f1 = index">
                  <div class="fun-row">
                    <div class="fun-row__form">
                      <mb-input-text
                        [formControl]="fun.control"
                        [defaultInput]="true"
                        [mbType]="fun.control.errors || fun.control.errors?.pattern ? 'error' : 'default'"
                        [mbShowError]="fun.control.errors !== null || fun.control.errors?.pattern !== null"
                        [mbErrors]="fun.control.errors"
                        [mbErrorDefs]="[
                          {
                            errorName: 'pattern',
                            errorDescription: 'modelOrganization.correctionOrganization.error.specialSymbol' | translate
                          },
                          {
                            errorName: 'duplicate',
                            errorDescription: 'Trùng chức năng chuyên biệt'
                          }
                        ]"
                        mbPlaceholderText="{{ 'modelOrganization.correctionOrganization.placeHoder.type' | translate }}"
                        [mbShowFlexEnd]="false"
                        (ngModelChange)="findDuplicate(shareData.data.orgAttributes)"
                      ></mb-input-text>
                    </div>
                    <div class="fun-row__action">
                      <a class="add-text">
                        <img alt="" src="assets/images/icon/add_circle_outline.svg" (click)="addFun(fun.control)"
                      /></a>
                      <a style="margin-left: 16px">
                        <img
                          alt=""
                          src="assets/images/icon/delete_outline.svg"
                          (click)="deleleFun(f1, shareData.data.orgAttributes)"
                        />
                      </a>
                    </div>
                  </div>
                </div>
              </td>
              <td>
                <div *ngFor="let fun of shareData.data?.orgAttributes; let f1 = index">
                  <div class="job-col">
                    <app-job-select
                      [list-input]="jobs"
                      [list-select]="fun.positions"
                      (eventAdd)="updateJob($event)"
                      class="form-row__input"
                    >
                    </app-job-select>
                  </div>
                </div>
              </td>
              <td *ngIf="shareData.type">
                <mb-date-picker
                  mbMode="time"
                  mbFormat="dd/MM/yyyy"
                  mbType="default"
                  [mbLabelText]="null"
                  formControlName="toDate"
                ></mb-date-picker>
              </td>
            </tr>
          </tbody>
        </nz-table>
      </div>
    </div>
  </form>
</div>
